{% extends '@KaitekFramework/Backend/module.html.twig' %}
{% trans_default_domain (modulename) %}
{% block begin_javascript_fix %}
<script type="text/javascript">
    {% endblock begin_javascript_fix %}


    {% block begin_javascript %}
    {{ parent() }}
    {{ modulename }}Obj.prototype = {
        storeConfig:{
            ProductTree:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldId:'name',fieldDisplay:"concat(name,'-',description)",options:{where:'O',finish:null}}
            ,ProductTreeG:{routeName:'ProductTree-getComboValues-special',table:'product_trees',fieldId:'name',fieldDisplay:"name",options:{where:'O',finish:null}}
            //,Client:{routeName:'BaseController-getComboValues',table:'clients'}
            //,ClientG:{routeName:'BaseController-getComboValues',table:'clients'}
        },
        init : function(){
            var t = this;
            {{ modulename }}Obj.superclass.init.call(t);
            const gridConfig = {
                cm: [
                    {header: "{{ 'TaskList.opname'|trans }}", dataIndex: 'tdescription', width: 300,filter:'single', type:'combo',fieldname:'opname',store:t.stores.ProductTreeG,alias:'t',operator:'='},
                    {header: "{{ 'TaskList.client'|trans }}", dataIndex: 'client', width: 150,filter:'single', type:'combo',store:t.extras.clients,alias:'t',operator:'='},
                    {header: "{{ 'TaskList.erprefnumber'|trans }}", dataIndex: 'erprefnumber', width: 80,filter:'single',alias:'t',operator:'%.%'},
                    {header: "{{ 'TaskList.plannedstart'|trans }}", dataIndex: 'plannedstart', width: 120,filter:'between', type:'date',alias:'t',render:'datetime'},
                    {header: "{{ 'TaskList.productcount'|trans }}", dataIndex: 'productcount', width: 80},
                    {header: "{{ 'TaskList.productdonecount'|trans }}", dataIndex: 'productdonecount', width: 80},
                    {header: "{{ 'TaskList.taskfromerp'|trans }}", dataIndex: 'taskfromerp', width: 50,renderer:mj.renderer.check(),filter:'single', type:'combo',alias:'t'}
                ]
            };
            t._setGridConfig(gridConfig);

            const formConfig= {
                items: [
                    new mj.form.field({
                        dataIndex: 'id',
                        hidden: true
                    }),
                    new mj.form.field({
                        dataIndex: 'version',
                        hidden: true
                    }),
                    new mj.form.combo({
                        title: "{{ 'TaskList.opname'|trans }}",
                        placeHolder: "{{ 'TaskList.opname_placeholder'|trans }}",
                        dataIndex: 'opname',
                        labelWidth : '120px',
                        mode: 'remote',
                        sameValueDisplay:false,
                        clearOnTriggerClick: true,
                        notEmpty: true,
                        grid: 's12 m6',
                        width:450,
                        store: t.stores.ProductTree
                    }),
                    new mj.form.combo({
                        title: "{{ 'TaskList.client'|trans }}",
                        placeHolder: "{{ 'TaskList.client_placeholder'|trans }}",
                        dataIndex: 'client',
                        labelWidth : '110px',
                        mode: 'local',
                        clearOnTriggerClick: true,
                        notEmpty: true,
                        right: true,
                        grid: 's12 m6',
                        store: t.extras.clients
                    }),
                    new mj.form.numberField({
                        title: "{{ 'TaskList.productcount'|trans }}",
                        dataIndex: 'productcount',
                        labelWidth : '120px',
                        notEmpty: true,
                        grid: 's12 m6'
                    }),
                    new mj.form.textField({
                        title: "{{ 'TaskList.erprefnumber'|trans }}",
                        dataIndex: 'erprefnumber',
                        maxLength: 50,
                        labelWidth : '120px',
                        grid: 's12 m6'
                    }),
                    new mj.form.dateField({
                        title: "{{ 'TaskList.deadline'|trans }}",
                        dataIndex: 'deadline',
                        labelWidth : '120px',
                        notEmpty: true,
                        grid: 's12 m6'
                    }),
                    new mj.form.dateField({
                        title: "{{ 'TaskList.plannedstart'|trans }}",
                        dataIndex: 'plannedstart',
                        labelWidth : '120px',
                        notEmpty: true,
                        grid: 's12 m6'
                    }),
                    new mj.form.timeField2({
                        title: "-",
                        dataIndex: 'plannedstarttime',
                        notEmpty: true,
                        labelWidth : '10px',
                        grid: 's12 m6',
                        right:true,
                        width : 50
                    }),
                    new mj.form.textArea({
                        title : "{{ 'TaskList.taskinfo'|trans }}",
                        dataIndex : 'taskinfo',
                        labelWidth : '120px',
                        width:300,
                        height:80,
                        readOnly : true,
                        disabled:true,
                        maxLength: 255
                    })
                ]
            };
            t._setFormConfig(formConfig);

            //t.buttons.print = t.grids.main.pbar.tbar.addButton({
            //    alt: mj.lng.glb.print,
            //    cls: 'btn-sm left',
            //    iconCls: 'mj-print',
            //    scope: t,
            //    handler: t._onButtonPrintClick
            //});
        }
        //,_onButtonPrintClick:function(){
        //    var t = this,f = this.forms.main;
        //    if (f.modulename && typeof Routing !== 'undefined') {
        //        var routeName = f.modulename + '-getReport';
        //        var route = Routing.getRoute(routeName);
        //        var pagerParams = {'pg':1,'lm':10000};
        //        var url = Routing.generate(routeName, pagerParams);
        //        if (route && route.methods && route.methods.length>0 && route.methods[0]) {
        //            t.waitMaskShow();
        //            $.ajax({
        //                url: url,
        //                method: "POST",
        //                headers: { 
        //                    "Content-Type": "application/json",
        //                    "X-HTTP-Method-Override": route.methods[0] 
        //                },
        //                dataType: 'binary',
        //                processData: false,
        //                success: function(data, textStatus, xhr) {
        //                    //t.activateTabGrid();
        //                    if(textStatus==='success'){
        //                        var filename = "";
        //                        var disposition = xhr.getResponseHeader('Content-Disposition');
        //                        if (disposition && disposition.indexOf('attachment') !== -1) {
        //                            var filenameRegex = /filename[^;=\n]*=((['"]).*?\2|[^;\n]*)/;
        //                            var matches = filenameRegex.exec(disposition);
        //                            if (matches != null && matches[1]) filename = matches[1].replace(/['"]/g, '');
        //                        }
        //                        var type = xhr.getResponseHeader('Content-Type');
        //                        var blob = typeof File === 'function'
        //                            ? new File([data], filename, { type: type })
        //                            : new Blob([data], { type: type });
        //                        if (typeof window.navigator.msSaveBlob !== 'undefined') {
        //                            // IE workaround for "HTML7007: One or more blob URLs were revoked by closing the blob for which they were created. These URLs will no longer resolve as the data backing the URL has been freed."
        //                            window.navigator.msSaveBlob(blob, filename);
        //t.waitMaskHide();
        //                        } else {
        //                            var URL = window.URL || window.webkitURL;
        //                            var downloadUrl = URL.createObjectURL(blob);
        //                            if (filename) {
        //                                // use HTML5 a[download] attribute to specify filename
        //                                var a = document.createElement("a");
        //                                // safari doesn't support this yet
        //                                if (typeof a.download === 'undefined') {
        //                                    window.location = downloadUrl;
        //t.waitMaskHide();
        //                                } else {
        //                                    a.href = downloadUrl;
        //                                    a.download = filename;
        //                                    document.body.appendChild(a);
        //                                    a.click();
        //t.waitMaskHide();
        //                                }
        //                            } else {
        //                                window.location = downloadUrl;
        //t.waitMaskHide();
        //                            }
        //                            setTimeout(function () { URL.revokeObjectURL(downloadUrl); }, 100); // cleanup
        //                        }
        //                    }
        //                },
        //                error: function(xhr, textStatus, errorThrown) {
        //                    t.waitMaskHide();
        //                    if(xhr.responseJSON&&xhr.responseJSON.message){
        //                        mj.message({
        //                            title: mj.lng.glb.error,
        //                            msg: xhr.responseJSON.message,
        //                            type: "error",
        //                            html: true
        //                        });
        //                    }
        //                },
        //                complete: function(jqXHR, textStatus) {
        //                    t.waitMaskHide();
        //                }
        //            });
        //        }
        //    }
        //}
        ,editSelectedRecord: function() {
            var selectedRecord = this.getSelectedRecord();
            if (selectedRecord !== false){
                //console.log(selectedRecord);
                if(selectedRecord.plannedstart!==''&&selectedRecord.plannedstart!==null){
                    selectedRecord.plannedstarttime=selectedRecord.plannedstart.split(' ')[1].substr(0,8);
                    selectedRecord.plannedstart=selectedRecord.plannedstart.split(' ')[0];
                }else{
                    selectedRecord.plannedstarttime='';
                }
                this.editData(selectedRecord);
            }
        }
        ,save: function() {
            var t = this,
                _f = this.forms,
                f = this.forms.main;
            t.trigger('beforesave');
            if (f.modulename && typeof Routing !== 'undefined') {
                //if (f.validate()) {
                    var id = f.getValue('id').id;
                    var versionField = f.getField('version');
                    var version = typeof versionField != "undefined" ? f.getValue('version').version : 0;
                    var mode = id ? 'update' : 'add';
                    var routeName = f.modulename + '-' + mode;
                    var route = Routing.getRoute(routeName);
                    var pagerParams = (t.grids && t.grids.main && t.grids.main.pbar) ? {
                        'pg': t.grids.main.pbar.current,
                        'lm': t.grids.main.pbar.limit
                    } : {};
                    var url = Routing.generate(routeName, id ? mj.apply(pagerParams, {
                        'id': id,
                        'v': version
                    }) : pagerParams);
                    var data = f.getValue();
                    if(data.plannedstarttime==''){
                        data.plannedstarttime='12:00:00';
                    }
                    data.plannedstart+=' '+data.plannedstarttime;
                    delete data.plannedstarttime;
                    data.menuId = t.id;
                    if (route && route.methods && route.methods.length>0 && route.methods[0]) {
                        t.waitMaskShow();
                        t._event='save';
                        $.ajax({
                            url: url,
                            method: "POST",
                            headers: { 
                                "Content-Type": "application/json",
                                "X-HTTP-Method-Override": route.methods[0] 
                            },
                            data: JSON.stringify(data),
                            dataType: 'json',
                            success: function(data, textStatus, jqXHR) {
                                t.reset(_f, data);
                                //t.activateTabGrid();
                                //t.waitMaskHide();
                            },
                            error: function(jqXHR, textStatus, errorThrown) {
                                t.waitMaskHide();
                                mj.message({
                                    title: mj.lng.glb.error,
                                    msg: jqXHR.responseJSON.message + "<br>" + jqXHR.responseJSON.file,
                                    type: "error",
                                    html: true
                                });
                            },
                            complete: function(jqXHR, textStatus) {
                                //t.waitMaskHide();
                            }
                        });
                    }
                //}
            }
        }
    };
    {% endblock begin_javascript %}



    {% block begin_default_module %}
    {{ parent() }}
    {% endblock begin_default_module %}



    {% block end_default_module %}
    {{ parent() }}
    {% endblock end_default_module %}


    {% block end_javascript %}
    {{ parent() }}
    {% endblock end_javascript %}


    {% block end_javascript_fix %}
</script>
{% endblock end_javascript_fix %}



{% block body %}
    {{ parent() }}
{% endblock body %}
